package eu.univento.core.api.languages;

import eu.univento.core.api.player.CustomPlayer;
import eu.univento.core.api.player.Perms;

/**
 * @author joethei
 * @version 2.0
 */
public class Messages {

     CustomPlayer player;

    Language_DE de = new Language_DE();
    Language_EN en = new Language_EN();
    Language_IT it = new Language_IT();

    Languages lang;

    public Messages(CustomPlayer player) {
        this.player = player;
        if(player.getLang().equals("DE")) this.lang = de;
        if(player.getLang().equals("IT")) this.lang = it;
        if(player.getLang().equals("EN")) this.lang = en;
    }

    public String PREFIX() {
        return " §7• §6univento§7.§eeu §7•  ";
    }

    public String UNKNOWN_ERROR() {
        return lang.UNKNOWN_ERROR();
    }
    public String NO_PERMS() {
        return lang.NO_PERMS();
    }
    public String ERROR() {
        return lang.ERROR();
    }
    public String NOT_ONLINE(String name) {
        return lang.NOT_ONLINE(name);
    }
    public String KICK_RESTART() {
        return lang.KICK_RESTART();
    }
    public String KICK_FULL() {
        return lang.KICK_FULL();
    }
    public String COMMAND_NOT_FOUND() {
        return lang.COMMAND_NOT_FOUND();
    }

    public String Core_FIX_OWN() {
        return lang.Core_FIX_OWN();
    }
    public String Core_FIX_OTHER(CustomPlayer p) {
        return lang.Core_FIX_OTHER(p);
    }
    public String Core_FIX_BY_OTHER(CustomPlayer p) {
        return lang.Core_FIX_BY_OTHER(p);
    }
    public String Core_NICK_ON() {
        return lang.Core_NICK_ON();
    }
    public String Core_NICK_OFF() {
        return lang.Core_NICK_OFF();
    }
    public String Core_BUILD_ON() {
        return lang.Core_BUILD_ON();
    }
    public String Core_BUILD_OFF() {
        return lang.Core_BUILD_OFF();
    }
    public String Core_BAN_NO_REASON() {
        return lang.Core_BAN_NO_REASON();
    }
    public String Core_BAN_USAGE() {
        return lang.Core_BAN_USAGE();
    }
    public String Core_BAN_BANNED(CustomPlayer p) {
        return lang.Core_BAN_BANNED(p);
    }
    public String Core_GM_USAGE() {
        return lang.Core_GM_USAGE();
    }
    public String Core_GM_CHANGED() {
        return lang.Core_GM_CHANGED();
    }
    public String Core_GLOBALMUTE_ON() {
        return lang.Core_GLOBALMUTE_ON();
    }
    public String Core_GLOBALMUTE_OFF() {
        return lang.Core_GLOBALMUTE_OFF();
    }
    public String Core_RUNAS_USAGE() {
        return lang.Core_RUNAS_USAGE();
    }
    public String Core_RUNAS_RUN(CustomPlayer p) {
        return lang.Core_RUNAS_RUN(p);
    }
    public String Core_SETRANK_USAGE() {
        return lang.Core_SETRANK_USAGE();
    }
    public String Core_SETRANK_KICK() {
        return lang.Core_SETRANK_KICK();
    }
    public String Core_SETRANK_NO_RANK() {
        return lang.Core_SETRANK_NO_RANK();
    }
    public String Core_SETRANK_SET(CustomPlayer p, Perms.Ranks rank) {
        return lang.Core_SETRANK_SET(p, rank);
    }
    public String Core_TS_ALLREADY_VERIFIED() {
        return lang.Core_TS_ALLREADY_VERIFIED();
    }
    public String Core_TS_VERIFIED() {
        return lang.Core_TS_VERIFIED();
    }
    public String Core_VANISH_ON() {
        return lang.Core_VANISH_ON();
    }
    public String Core_VANISH_OFF() {
        return lang.Core_VANISH_OFF();
    }
    public String Core_SERVER_MUTED() {
        return lang.Core_SERVER_MUTED();
    }
    public String Core_CHAT_CLEARED(CustomPlayer p) { return lang.Core_CHAT_CLEARED(p);}
    public String Core_TAB_TITLE() { return lang.Core_TAB_TITLE(); }

    public String Lobby_PLAYERS_HIDE() {
        return lang.Lobby_PLAYERS_HIDE();
    }
    public String Lobby_PLAYERS_SHOW() {
        return lang.Lobby_PLAYERS_SHOW();
    }
    public String Lobby_AUTONICK_ON() {
        return lang.Lobby_AUTONICK_ON();
    }
    public String Lobby_AUTONICK_OFF() {
        return lang.Lobby_AUTONICK_OFF();
    }
    public String Lobby_FORCEFIELD_ON() {
        return lang.Lobby_FORCEFIELD_ON();
    }
    public String Lobby_FORCEFIELD_OFF() {
        return lang.Lobby_FORCEFIELD_OFF();
    }
    public String Lobby_SILENT_LOBBY_ON() {
        return lang.Lobby_SILENT_LOBBY_ON();
    }
    public String Lobby_SILENT_LOBBY_OFF() {
        return lang.Lobby_SILENT_LOBBY_OFF();
    }
    public String Lobby_PLAYING_MUSIC_PREFIX() {
        return lang.Lobby_PLAYING_MUSIC_PREFIX();
    }
    public String Lobby_FOUND_ITEM_PREFIX() {
        return lang.Lobby_FOUND_ITEM_PREFIX();
    }
    public String Lobby_SET_LOCATION() {
        return lang.Lobby_SET_LOCATION();
    }
    public String Lobby_SET_LOCATION_USAGE() {
        return lang.Lobby_SET_LOCATION_USAGE();
    }
    public String Lobby_DROP_ITEM_USAGE() {
        return lang.Lobby_DROP_ITEM_USAGE();
    }
    public String Lobby_DROP_ITEM() {
        return lang.Lobby_DROP_ITEM();
    }
    public String Lobby_SET_SIGN() {
        return lang.Lobby_SET_SIGN();
    }
    public String Lobby_JOIN_TITLE_1() {
        return lang.Lobby_JOIN_TITLE_1();
    }
    public String Lobby_JOIN_TITLE_2() {
        return lang.Lobby_JOIN_TITLE_2();
    }
    public String Lobby_PET_ADD() {
        return lang.Lobby_PET_ADD();
    }
    public String Lobby_PET_REMOVE() {
        return lang.Lobby_PET_REMOVE();
    }
    public String Lobby_PARKOUR_ON() {
        return lang.Lobby_PARKOUR_ON();
    }
    public String Lobby_PARKOUR_OFF() {
        return lang.Lobby_PARKOUR_OFF();
    }

    public String LobbyItems_NAVIGATOR() {
        return lang.LobbyItems_NAVIGATOR();
    }
    public String LobbyItems_PLAYER_HIDER_ON() {
        return lang.LobbyItems_PLAYER_HIDER_ON();
    }
    public String LobbyItems_PLAYER_HIDER_OFF() {
        return lang.LobbyItems_PLAYER_HIDER_OFF();
    }
    public String LobbyItems_AUTO_NICK() {
        return lang.LobbyItems_AUTO_NICK();
    }
    public String LobbyItems_SILENT_LOBBY() {
        return lang.LobbyItems_SILENT_LOBBY();
    }
    public String LobbyItems_FORCEFIELD() {
        return lang.LobbyItems_FORCEFIELD();
    }
    public String LobbyItems_FUN_CHEST() {
        return lang.LobbyItems_FUN_CHEST();
    }
    public String LobbyItems_PROFILE() {
        return lang.LobbyItems_PROFILE();
    }
    public String LobbyItems_YOUTUBER() { return lang.LobbyItems_YOUTUBER(); }
    public String LobbyItems_SUGGESTION() { return lang.LobbyItems_SUGGESTION(); }
    public String LobbyItems_SPAWN() {
        return lang.LobbyItems_SPAWN();
    }
    public String LobbyItems_PREMIUMHUB() {
        return lang.LobbyItems_PREMIUMHUB();
    }
    public String LobbyItems_MAYA() {
        return lang.LobbyItems_MAYA();
    }
    public String LobbyItems_WOOLGET() { return lang.LobbyItems_WOOLGET(); }
    public String LobbyItems_BUILDSERVER() {
        return lang.LobbyItems_BUILDSERVER();
    }
    public String LobbyItems_PLAYERS_ONLINE() {
        return lang.LobbyItems_PLAYERS_ONLINE();
    }
    public String LobbyItems_GADGETS() {
        return lang.LobbyItems_GADGETS();
    }
    public String LobbyItems_MUSIC() {
        return lang.LobbyItems_MUSIC();
    }
    public String LobbyItems_PARTICLE() {
        return lang.LobbyItems_PARTICLE();
    }
    public String LobbyItems_PETS() {
        return lang.LobbyItems_PETS();
    }
    public String LobbyItems_YOUR_PET() { return lang.LobbyItems_YOUR_PET(); }
    public String LobbyItems_PETS_NAME() { return lang.LobbyItems_PETS_NAME(); }
    public String LobbyItems_PETS_AGE() { return lang.LobbyItems_PETS_AGE(); }
    public String LobbyItems_PETS_RIDE() { return lang.LobbyItems_PETS_RIDE(); }
    public String LobbyItems_PETS_REMOVE() { return lang.LobbyItems_PETS_REMOVE(); }
    public String LobbyItems_PETS_PIG() { return lang.LobbyItems_PETS_PIG(); }
    public String LobbyItems_PETS_COW() { return lang.LobbyItems_PETS_COW(); }
    public String LobbyItems_PETS_CHICKEN() { return lang.LobbyItems_PETS_CHICKEN(); }
    public String LobbyItems_PETS_RABBIT() { return lang.LobbyItems_PETS_RABBIT(); }
    public String LobbyItems_PETS_MUSHROM_COW () { return lang.LobbyItems_PETS_MUSHROM_COW(); }
    public String LobbyItems_PLAYER_MENU() { return lang.LobbyItems_PLAYER_MENU(); }
    public String LobbyItems_PLAYER_FRIEND() { return lang.LobbyItems_PLAYER_FRIEND(); }
    public String LobbyItems_PLAYER_PARTY() { return lang.LobbyItems_PLAYER_PARTY(); }
    public String LobbyItems_PLAYER_PROFILE() { return lang.LobbyItems_PLAYER_PROFILE(); }
    public String LobbyItems_PLAYER_STATS() { return lang.LobbyItems_PLAYER_STATS();}
    public String LobbyItems_STATS() {
        return lang.LobbyItems_STATS();
    }
    public String LobbyItems_FRIENDS() {
        return lang.LobbyItems_FRIENDS();
    }
    public String LobbyItems_SETTINGS() {
        return lang.LobbyItems_SETTINGS();
    }
    public String LobbyItems_SETTINGS_FASTMENU() { return lang.LobbyItems_SETTINGS_FASTMENU();}
    public String LobbyItems_SETTINGS_SERVER_TELEPORT() { return lang.LobbyItems_SETTINGS_SERVER_TELEPORT(); }
    public String LobbyItems_SETTINGS_PARTY_REQUESTS() {
        return lang.LobbyItems_SETTINGS_PARTY_REQUESTS();
    }
    public String LobbyItems_SETTINGS_FRIEND_REQUESTS() {
        return lang.LobbyItems_SETTINGS_FRIEND_REQUESTS();
    }
    public String LobbyItems_SETTINGS_CHATSOUNDS() {
        return lang.LobbyItems_SETTINGS_CHATSOUNDS();
    }
    public String LobbyItems_SETTINGS_EFFECTS() {
        return lang.LobbyItems_SETTINGS_EFFECTS();
    }
    public String LobbyItems_SETTINGS_LANGUAGES() {
        return lang.LobbyItems_SETTINGS_LANGUAGES();
    }
    public String LobbyItems_SETTINGS_ON() {
        return lang.LobbyItems_SETTINGS_ON();
    }
    public String LobbyItems_SETTINGS_OFF() {
        return lang.LobbyItems_SETTINGS_OFF();
    }
    public String LobbyItems_BACK() { return lang.LobbyItems_BACK(); }

    public String LobbyBoard_COINS() { return lang.LobbyBoard_COINS(); }
    public String LobbyBoard_NEW() { return lang.LobbyBoard_NEW(); }
    public String LobbyBoard_NEWS() { return lang.LobbyBoard_NEWS(); }
    public String LobbyBoard_TS() { return lang.LobbyBoard_TS(); }
    public String LobbyBoard_FORUM() { return lang.LobbyBoard_FORUM(); }
    public String LobbyBoard_FOUND_SECRETS() { return lang.LobbyBoard_FOUND_SECRETS(); }

        public class Build {
            public String PREFIX = "• §bTeam§3Vento • ";
        }

    public static class Console{
        public static String NOT_A_PLAYER = "You are not a valid player";
    }
}