package eu.univento.core.api.map;

import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;


/**
 * @author RainyCrafter
 */
public class Region {

    World w;

    int minx;
    int miny;
    int minz;

    int maxx;
    int maxy;
    int maxz;

    String name;



    public Region(Location loc1, Location loc2, String name) {

        w = loc1.getWorld();

        this.name = name;

        minx = Math.min(loc1.getBlockX(), loc2.getBlockX());
        miny = Math.min(loc1.getBlockY(), loc2.getBlockY());
        minz = Math.min(loc1.getBlockZ(), loc2.getBlockZ());

        maxx = Math.max(loc1.getBlockX(), loc2.getBlockX());
        maxy = Math.max(loc1.getBlockY(), loc2.getBlockY());
        maxz = Math.max(loc1.getBlockZ(), loc2.getBlockZ());



    }
    public void save(){
        File file = new File("plugins/Core/regions.yml");
        FileConfiguration cfg = YamlConfiguration.loadConfiguration(file);

        cfg.set(name+".W", w.getName());

        cfg.set(name+".Min.X", minx);
        cfg.set(name+".Min.Y", miny);
        cfg.set(name+".Min.Z", minz);

        cfg.set(name+".Max.X", maxx);
        cfg.set(name+".Max.Y", maxy);
        cfg.set(name+".Max.Z", maxz);

        try {
            cfg.save(file);
        } catch (IOException e) {
            e.printStackTrace();
        }

    }
    public boolean between(int w1, int zw, int w2){
        if(zw >= w1 && zw <= w2){
            return true;
        }
        return false;
    }

    public boolean isInside(Location loc) {
        if (loc.getWorld() != w) {
            return false;
        }

        if (between(minx, loc.getBlockX(), maxx) && between(miny, loc.getBlockY(), maxy) && between(minz, loc.getBlockZ(), maxz)) {
            return true;
        }
        return false;
    }


}