package eu.univento.core.api.server;

import java.util.regex.Pattern;

/**
 * @author joethei
 * @version 0.1
 */
public class ServerInfo {

    String name;
    ServerPinger pinger;

    public ServerInfo(String name) {
        this.name = name;
        pinger = new ServerPinger(name, 200);
        pinger.ping();
    }

    public String getName() {
        return name;
    }

    public Game getGame() {
        String[] parts = getMotd().split(Pattern.quote(";"));
        return Game.valueOf(parts[0]);
    }

    public String getGameState() {
        String[] parts = getMotd().split(Pattern.quote(";"));
        return parts[1];
    }

    public int getOnlinePlayers() {
        return pinger.getPlayerCount();
    }

    public int getMaxPlayers() {
        return pinger.getMaxPlayers();
    }

    public String getMotd() {
        return pinger.getMotd();
    }

}