package eu.univento.core.commands;

import eu.univento.core.Core;
import eu.univento.core.api.AutoCommand;
import eu.univento.core.api.languages.Messages;
import eu.univento.core.api.player.CustomPlayer;
import eu.univento.core.api.player.Perms.Ranks;
import org.bukkit.Bukkit;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import java.util.List;

/**
 * @author joethei
 * @version 1.0
 */
public class ChatClear extends AutoCommand<Core> {

    public ChatClear(Core plugin, String command, String description, String... aliases) {
        super(plugin, command, description, aliases);
    }

    @Override
    public boolean execute(CommandSender sender, String label, String[] args) {
        if(sender instanceof Player) {
            CustomPlayer p = CustomPlayer.getPlayer(sender.getName());
            Messages msgs = new Messages(p);
            if(p.isAllowed(Ranks.Supporter)) {
                for(int i = 0; i <= 100; i++) {
                    Bukkit.broadcastMessage(" ");
                }
                for(Player players : Bukkit.getOnlinePlayers()) {
                    CustomPlayer player = CustomPlayer.getPlayer(players);
                    if (player.isAllowed(Ranks.Supporter)) {
                        Messages messages = new Messages(player);
                        player.sendMessage(messages.Core_CHAT_CLEARED(p));
                    }
                }
            }else {
                p.sendMessage(msgs.NO_PERMS());
            }
        }else {
            sender.sendMessage(Messages.Console.NOT_A_PLAYER);
        }
        return true;
    }

    @Override
    public List<String> tabComplete(CommandSender sender, String label, String[] args) {
        return null;
    }
}