package eu.univento.core.commands;

import eu.univento.core.Core;
import eu.univento.core.api.AutoCommand;
import eu.univento.core.api.languages.Messages;
import eu.univento.core.api.player.CustomPlayer;
import eu.univento.core.api.player.Perms.Ranks;
import eu.univento.core.api.server.ServerSettings;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import java.util.List;

/**
 * mutes the whole server
 * @author joethei
 * @version 1.0
 */
public class GlobalMute extends AutoCommand<Core>{

	/**
	 * @param plugin main class
	 * @param command command to execute
	 * @param description describes the command
	 * @param aliases aliases of command
	 */
	public GlobalMute(Core plugin, String command, String description, String[] aliases) {
		super(plugin, command, description, aliases);
	}

	@Override
	public boolean execute(CommandSender sender, String label, String[] args) {
		if(sender instanceof Player) {
			CustomPlayer p = CustomPlayer.getPlayer(sender.getName());
			Messages msgs = new Messages(p);
			if(p.isAllowed(Ranks.Moderator)) {
				if(ServerSettings.isMute()) {
                    ServerSettings.setMute(false);
					p.sendMessage(msgs.Core_GLOBALMUTE_OFF());
				}else {
                    ServerSettings.setMute(true);
					p.sendMessage(msgs.Core_GLOBALMUTE_ON());
				}
			}else {
				p.sendMessage(msgs.NO_PERMS());
			}
		}else {
			sender.sendMessage(Messages.Console.NOT_A_PLAYER);
		}
		return false;
	}

	@Override
	public List<String> tabComplete(CommandSender sender, String label, String[] args) {
		return null;
	}

}