package eu.univento.core.commands;

import eu.univento.core.Core;
import eu.univento.core.api.AutoCommand;
import eu.univento.core.api.languages.Messages;
import eu.univento.core.api.player.CustomPlayer;
import eu.univento.core.api.player.Perms.Ranks;
import org.bukkit.Bukkit;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import java.util.List;
import java.util.stream.Collectors;

/**
 * lets other player run commands
 * @author joethei
 * @version 1.0
 */
public class RunAs extends AutoCommand<Core>{

	/**
	 * @param plugin main class
	 * @param command command to execute
	 * @param description describes the command
	 * @param aliases aliases of command
	 */
	public RunAs(Core plugin, String command, String description, String[] aliases) {
		super(plugin, command, description, aliases);
	}


	@Override
	public boolean execute(CommandSender sender, String label, String[] args) {
		if(sender instanceof Player) {
			CustomPlayer p = CustomPlayer.getPlayer(sender.getName());
			Messages msgs = new Messages(p);
			if(p.isAllowed(Ranks.Admin)) {
				if(args.length >= 2) {
					CustomPlayer t = CustomPlayer.getPlayer(Bukkit.getPlayer(args[0]).getName());
					if(t != null) {
						String msg = "";
						for(int i = 1; i < args.length; i++) {
							msg = msg + args[i] + " ";
						}
						t.chat(msg);
						p.sendMessage(msgs.Core_RUNAS_RUN(t));
						return true;
					}else {
						p.sendMessage(msgs.NOT_ONLINE(args[0]));
					}
				}else {
					p.sendMessage(msgs.Core_RUNAS_USAGE());
				}
			}else {
				p.sendMessage(msgs.NO_PERMS());
			}
		}else {
			sender.sendMessage(Messages.Console.NOT_A_PLAYER);
		}
		return false;
	}
	
	@Override
	public List<String> tabComplete(CommandSender sender, String label, String[] args) {
		return Bukkit.getOnlinePlayers().stream().map(Player::getDisplayName).collect(Collectors.toList());
	}


}
