package eu.univento.core.commands;

import eu.univento.core.Core;
import eu.univento.core.api.AutoCommand;
import eu.univento.core.api.languages.Messages;
import eu.univento.core.api.player.CustomPlayer;
import eu.univento.core.api.twitch.Twitch_API;
import eu.univento.core.api.twitch.Twitch_Stream;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import java.util.List;

/**
 * send info about twitch streams
 * @author joethei
 * @version 1.0
 */
public class Twitch extends AutoCommand<Core>{

	/**
	 * @param plugin main class
	 * @param command command to execute
	 * @param description describes the command
	 * @param aliases aliases of command
	 */
	public Twitch(Core plugin, String command, String description, String[] aliases) {
		super(plugin, command, description, aliases);
	}

	@Override
	public boolean execute(CommandSender sender, String label, String[] args) {
		if(sender instanceof Player) {
			CustomPlayer p = CustomPlayer.getPlayer(sender.getName());
			Messages msgs = new Messages(p);
			if(args.length == 1) {
				Twitch_Stream stream = Twitch_API.getStream(args[0]);
				if(stream != null) {
					p.sendMessage("§a" + stream.getBroadcaster());
					p.sendMessage("§aBenutzername: " + stream.getUsername());
					p.sendMessage("§aSpiel: " + stream.getMeta_game());
					p.sendMessage("§aKategorie: " + stream.getCategory());
					p.sendMessage("§aTitel: " + stream.getTitle());
					p.sendMessage("§aStatus: " + stream.getStatus());
					p.sendMessage("§aZuschauer:" + stream.getChannel_view_count());
					p.sendMessage("§aSprachen: " + stream.getGeo());
					p.sendMessage("§aOnline seit: " + stream.getUp_time());
				}else {
					p.sendMessage(msgs.PREFIX() + "§aDen Benutzer gibt es nicht");
				}
			}else {
				p.sendMessage(msgs.PREFIX() + "§cNutze /twitch <Name>");
			}
		}else {
			sender.sendMessage(Messages.Console.NOT_A_PLAYER);
		}
		return true;
	}

	@Override
	public List<String> tabComplete(CommandSender sender, String label, String[] args) {
		return null;
	}

}